package java.lang;

/**
 * This object has to purposes. First it is used to make method signatures
 * unique, by adding this object as parameter to the argument. Second, it is used to pass the arguments of the caller to the proxy
 * method (it is used solely by the instrumented code).
 *
 * @author schuler
 *
 */
public class MyUniqueObject {

	private static int objectCounter = 100;

	private int methodID;

	private int classID;

	private int objectID;

	public MyUniqueObject() {
		this(-1, -2);
	}

	public MyUniqueObject(int classID, int methodID) {
		this.classID = classID;
		this.methodID = methodID;
		this.objectID = 0;
	}

	public MyUniqueObject(int classID, int methodID, int objectID) {
		this.classID = classID;
		this.methodID = methodID;
		this.objectID = objectID;
	}

	public int getClassID() {
		return classID;
	}

	public void setClassID(int classID) {
		this.classID = classID;
	}

	public int getMethodID() {
		return methodID;
	}

	public void setMethodID(int methodID) {
		this.methodID = methodID;
	}

	public int getObjectID() {
		return objectID;
	}

	public void setObjectID(int objectID) {
		this.objectID = objectID;
	}

	/**
	 * Return a unique object ID, used by instrumented classes
	 *
	 * @return
	 */
	public static int getID() {
		return ++objectCounter;
	}

}
