package org.softevo.apibirthmark.anttasks;

import org.apache.tools.ant.Task;

import org.softevo.apibirthmark.transformation.FileTransformer;

/**
 * Ant Task to transform an API (insert Proxy methods)
 *
 * @author schuler
 *
 */
public class APITransformerTask extends Task {

	protected String idMapDestination;

	protected String fileSource;

	protected String fileDestination;

	protected String maxKeyFile;

	protected String idMapSource;

	/* (non-Javadoc)
	 * @see org.apache.tools.ant.Task#execute()
	 */
	public void execute() {
		log("FileTransformer.transformAPI(" + fileSource + ", "
				+ fileDestination + ", " + idMapDestination + ", " + maxKeyFile
				+ ", " + idMapSource + " ); ");
		FileTransformer.transformAPI(fileSource, fileDestination,
				idMapDestination, maxKeyFile, idMapSource);
	}

	/**
	 * Set source: the jar or directory that should be transformed
	 *
	 * @param path
	 *            path to jar or directory
	 */
	public void setSource(String path) {
		fileSource = path;
	}

	/**
	 * Set destination for the transformed version: jar or directory
	 *
	 * @param path
	 *            path to jar or directory where the transformed version is
	 *            saved
	 */
	public void setDestination(String s) {
		fileDestination = s;
	}

	/**
	 * set the location where the resulting IDMap (contains IDs and
	 * corresponding class names) is saved.
	 *
	 * @param path
	 *            location of the resulting IDMap
	 */
	public void setIDMapDestination(String path) {
		idMapDestination = path;
	}

	/**
	 * Set the source IDMap. If methods will be redefined IDs from this Map will
	 * be used
	 *
	 * @param path
	 *            location of the IDMap
	 */
	public void setIDMapSource(String path) {
		idMapSource = path;
	}

	/**
	 * Set the file from which a maximum key is read. This can be used to avoid
	 * the same ID during multiple instrumentations.
	 *
	 * @param path
	 *            location of the IDMap
	 */
	public void setMaxKeyFile(String path) {
		maxKeyFile = path;
	}

}
