package org.softevo.apibirthmark.anttasks;

import org.softevo.apibirthmark.transformation.FileTransformer;

/**
 * Ant Task to transform a library that is on the classpath but should not be
 * observed
 * 
 * @author schuler
 * 
 */
public class IntermediateTransformerTask extends APITransformerTask {

	protected String apiIDMap;

	/* (non-Javadoc)
	 * @see org.apache.tools.ant.Task#execute()
	 */
	public void execute() {
		try {
			FileTransformer.transformIntermediateLibrary(fileSource,
					fileDestination, apiIDMap, idMapDestination, maxKeyFile);
		} catch (Exception e) {
			e.printStackTrace();
			throw new RuntimeException(e.getMessage());
		}

	}

	/** Set the API IDMap. Methods contained in this IDMap will be observed.
	 * @param path location of the IDMap
	 */
	public void setApiIDMap(String path) {
		this.apiIDMap = path;
	}
	
	/* (non-Javadoc)
	 * @see anttasks.APITransformerTask#setIDMapSource(java.lang.String)
	 */
	public void setIDMapSource(String apiIDMap) {
		this.apiIDMap = apiIDMap;
	}

}
