package org.softevo.apibirthmark.asmadapters.calls.observed;

/**
 * Used to decide if call to a method or constructor should be instrumented or
 * not
 *
 * @author schuler
 *
 */
public interface ObservedCalls {

	/**
	 * Returns true if this method should be instrumented
	 *
	 * @param owner
	 *            Name of the class that contains given method
	 * @param methodName
	 *            Name of the method
	 * @param desc
	 *            Method Descriptor
	 * @return True if call to this method should be instrumented
	 */
	public boolean isObservedMethod(String owner, String methodName, String desc);

	/**
	 * Returns true if this constructor should be instrumented
	 *
	 * @param owner
	 *            Name of the class that contains given method
	 * @param desc
	 *            Method Descriptor
	 * @return True if call to this constructor should be instrumented
	 */
	public boolean isObservedConstructor(String owner, String desc);

}
