package org.softevo.apibirthmark.constants;

import org.softevo.apibirthmark.util.Property;

/**
 * Interface that holds the constants that are used in this project. Properties
 * that are shared between the ant build and the program are loaded from the ant
 * properties file.
 *
 * @author schuler
 *
 */
public interface Constants {

	public static final int STATICOBJECTID = -99;

	public static final int CONSTRUCTORID = -98;

	public static final int APIID = -97;

	public static final String OUTPUT_DIRECTORY = Property
			.getProperty("output.dir");

	public static final String RESULT_DIRECTORY = OUTPUT_DIRECTORY
			+ "/results/";

	public static final String IDFILE_DIR = Property.getProperty("idfile.dir");

	public static final String RUNTIME_IDMAP_LOCATION = Property
			.getProperty("idfile.runtime");

	public static final String DEFAULT_IDMAP_LOCATION = OUTPUT_DIRECTORY
			+ "defaultIDMap.xml";

	public static final String VALIDATION_OUTPUT_DIRECTORY = Property
			.getProperty("validation.src.dir");

	public static final String VALIDATION_OBSERVED_TRACE_FILE = Property
			.getProperty("validation.resultFile");

	public static final String VALIDATION_EXPECTED_TRACE_FILE = VALIDATION_OUTPUT_DIRECTORY
			+ "expectetTrace.ser";

	public static final String TRACE_HANDLER_PROPERTY = "traceHandler";

	public static final String CALLE_HANDLER = "callee";

	public static final String OBJECT_WINDOW_TRACE_HANDLER = "objectWindow";

	public static final String CLASS_WINDOW_TRACE_HANDLER = "classWindow";

	public static final String GLOBAL_WINDOW_TRACE_HANDLER = "globalWindow";

	public static final String EXCLUDE_TRACE_HANDLER = "exclude";

	public static final String TOTAL_TRACE_HANDLER = "total";

	public static final String VALIDATION_TRACE_HANDLER = "validation";

	public static final String CALLER_EXCLUDE_TRACE_HANDLER = "caller";

	public static final String CALLER_CLASS_EXCLUDE_TRACE_HANDLER = "callerclass";

	public static final String CALLEE_CLASS_EXCLUDE_TRACE_HANDLER = "calleeclass";

	public static final Object GLOBAL_WINDOW_EXCLUDE_TRACE_HANDLER = "globalwindow";

	public static final String VALIDATION_EXPECTED_IDMAP = VALIDATION_OUTPUT_DIRECTORY
			+ "expectedIDMap.xml";

	public static final String VALIDATION_OBSERVED_IDMAP = Property
			.getProperty("validation.idfile");

	public static final String PROPERTY_RESULT_FILE = "resultFile";

	public static final String PROPERTY_WINDOW_SIZE = "windowSize";

	public enum ImageReaders {
		JAI, SIXLEGS, IMAGERO, JIMI, VISUALTEK, JIU
	}

	public static final int NO_METHOD_ID = 0;

	public static final String NO_CLASSNAME = "noClass";

	public static final String NO_METHODNAME = "noMethod";

	public static final String COUNTER_PREFIX = "COUNTER";

	public static final String COMPARE_PREFIX = "COMPARE_";

	public static final String KEY_OBSERVED_CALLS = "observedCalls";

	public static final String[] excludedClasses = new String[] {
			"java/lang/Object", "java/lang/String", "java/lang/StringBuffer",
			"org/xml/sax/helpers/DefaultHandler" };

	public static final String EXCLUDE_FILE = Property
			.getProperty("exclude.file");

	public static final int FILL_OBJECT_ID = 0;

	public static final int FILL_METHOD_ID = 0;

	public static final int FIll_CLASS_ID = 0;

	public static final String PNG_RESULT_DIR = Property
			.getProperty("png.birthmark.dir");

	/**
	 * Classes to be excluded. JVM hangs at startup if these two classes are
	 * modified. (for Sun's Java 1.4 we only need to exclude java/lang/Object)
	 */
	public static final String[] EXCLUDE_CLASSES = { "java/lang/Object",
			"java/lang/Number" };

	public static final String CONTAINED_BIRTHMARK_KEY = "birthmarkComparison";

}
