package org.softevo.apibirthmark.tracing;

import java.io.File;

import org.softevo.apibirthmark.constants.Constants;

import org.softevo.apibirthmark.tracing.result.AbstractTraceResult;
import org.softevo.apibirthmark.tracing.result.birthmark.Birthmark;
import org.softevo.apibirthmark.tracing.result.birthmark.callee.CalleeSequenceBirthmark;
import org.softevo.apibirthmark.tracing.result.birthmark.callee.ContainedCalleeSequenceBirthmark;
import org.softevo.apibirthmark.tracing.result.process.ResultFromFiles;

/**
 * Class compares two results.
 *
 * @author schuler
 *
 */
public class BirthmarkCompare {



	public static void main(String[] args) {
		if (args.length < 2) {
			System.out.println("supply two files to compare");
			return;
		}
		File file1 = new File(args[0]);
		File file2 = new File(args[1]);
		AbstractTraceResult tResult1 = ResultFromFiles
				.getTraceObjectResult(file1);
		AbstractTraceResult tResult2 = ResultFromFiles
				.getTraceObjectResult(file2);

		Birthmark birthmark;
		birthmark = new CalleeSequenceBirthmark(
				tResult1, tResult2);

		if("contained".equals(System.getProperty(Constants.CONTAINED_BIRTHMARK_KEY))){
			System.out.println("Using contained birthmark");
			birthmark = new ContainedCalleeSequenceBirthmark(tResult1, tResult2);
		}
		birthmark.computeBirthmark();

		float value = birthmark.getBirthmarkValue();
		System.out.println("Similarity between the two results: " + value);
	}

}
