package org.softevo.apibirthmark.tracing.mapping;

/**
 * Helper class to hold a class and a method ID
 *
 * @author schuler
 *
 */
public class ClassMethodID {

	private int classID;

	private int methodID;

	/**
	 * Creates a ClassMethodID for given class and method IDs
	 *
	 * @param classID
	 *            ID of the class
	 * @param functionID
	 *            ID of the method
	 */
	public ClassMethodID(int classID, int functionID) {
		this.classID = classID;
		this.methodID = functionID;
	}

	/*
	 * (non-Javadoc)
	 *
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	@Override
	public boolean equals(Object obj) {
		ClassMethodID cfi = (ClassMethodID) obj;
		return (cfi.methodID == methodID) & (cfi.classID == classID);
	}

	/*
	 * (non-Javadoc)
	 *
	 * @see java.lang.Object#hashCode()
	 */
	@Override
	public int hashCode() {
		return 31 * classID + methodID;
	}

	/**
	 * Getter for class ID
	 *
	 * @return The class ID
	 */
	public int getClassID() {
		return classID;
	}

	/**
	 * Getter for method ID
	 *
	 * @return The method ID
	 */
	public int getMethodID() {
		return methodID;
	}

}
