package org.softevo.apibirthmark.tracing.result.birthmark;

import org.softevo.apibirthmark.tracing.result.AbstractTraceResult;

public abstract class Birthmark {

	protected final String FLOAT_FORMAT = " %.4f";

	protected AbstractTraceResult firstResult;

	protected AbstractTraceResult compareResult;

	/**
	 * Returns a similarity value for the two birthmarks. Important:
	 * ComputeBirthmark must be called first.
	 *
	 * @return The similarity value that is >0 and <1.
	 */
	public abstract float getBirthmarkValue();

	/**
	 * computes the Birthmark
	 */
	public abstract void computeBirthmark();

	/**
	 * @return the compareResult
	 */
	public AbstractTraceResult getCompareResult() {
		return compareResult;
	}

	/**
	 * @return the firstResult
	 */
	public AbstractTraceResult getFirstResult() {
		return firstResult;
	}

	/**
	 * @param compareResult the compareResult to set
	 */
	public void setCompareResult(AbstractTraceResult compareResult) {
		this.compareResult = compareResult;
	}

	/**
	 * @param firstResult the firstResult to set
	 */
	public void setFirstResult(AbstractTraceResult firstResult) {
		this.firstResult = firstResult;
	}



}