package org.softevo.apibirthmark.tracing.result.birthmark;

/**
 * Contained birthmark computes how much of one part is contained in the other
 * and takes the maximum of these two values as a birthmark.
 *
 * @author schuler
 *
 */
public abstract class ContainedBirthmark extends Birthmark {

	/* (non-Javadoc)
	 * @see org.softevo.apibirthmark.tracing.result.birthmark.Birthmark#getBirthmarkValue()
	 */
	@Override
	public float getBirthmarkValue() {
		float firstSupportingSequences = getFirstSupportingSequences();
		float compareSupportingSequences = getCompareSupportingSequences();
		float firstBirthmark = firstSupportingSequences / getFirstDivisor();
		float secondBirthmark = compareSupportingSequences
				/ getCompareDivisor();
		return Math.max(firstBirthmark, secondBirthmark);
	}

	protected abstract float getCompareDivisor();

	protected abstract float getFirstDivisor();

	protected abstract float getCompareSupportingSequences();

	protected abstract float getFirstSupportingSequences();

}
