package org.softevo.apibirthmark.tracing.tracehandler;

import java.util.HashMap;

import org.softevo.apibirthmark.tracing.Tracer.TraceObject;
import org.softevo.apibirthmark.tracing.tracehandler.window.TraceObjectWindow;
import org.softevo.apibirthmark.constants.Constants;

public class CallerObjectHandler extends ObjectTraceHandler {


	public void handle(TraceObject traceObject) {
		TraceObjectWindow window;
		int key = traceObject.callerObjectID;
		synchronized (sequenceMap) {
			HashMap<Integer, TraceObjectWindow> windowHashMap = sequenceMap;
			if (key == Constants.STATICOBJECTID) {
				if (ignoreStaticSequences) {
					return;
				}
				key = traceObject.callerClassID;
				windowHashMap = staticHashMap;
			}
			if (windowHashMap.containsKey(key)) {
				window = windowHashMap.get(key);
			} else {
				window = new TraceObjectWindow();
				windowHashMap.put(key, window);
			}
			window.addCall(traceObject);
			if (window.isFull()) {
				windowContainer.add(window);
			}
		}
	}
}
