package org.softevo.apibirthmark.tracing.tracehandler;

import java.util.Vector;

import org.softevo.apibirthmark.tracing.Tracer;
import org.softevo.apibirthmark.tracing.Tracer.TraceObject;
import org.softevo.apibirthmark.tracing.result.TraceObjectResult;
import org.softevo.apibirthmark.tracing.tracehandler.window.TraceObjectResultWindow;
import org.softevo.apibirthmark.util.ObjectIO;

/**
 * Collects  all calls in a vector
 * @author schuler
 *
 */
public class TotalTraceHandler implements TraceObjectHandler {

	Vector<TraceObject> traceObjectVector = new Vector<TraceObject>();

	/* (non-Javadoc)
	 * @see tracing.tracehandler.TraceObjectHandler#handle(tracing.Tracer.TraceObject)
	 */
	public void handle(TraceObject traceObject) {
		traceObjectVector.add(traceObject);
	}

	/* (non-Javadoc)
	 * @see tracing.tracehandler.TraceObjectHandler#report()
	 */
	public void report() {
		TraceObjectResultWindow traceObjectResultWindow = new TraceObjectResultWindow(traceObjectVector.toArray(new TraceObject[0]));
		TraceObjectResult traceObjectResult = new TraceObjectResult(new TraceObjectResultWindow[]{traceObjectResultWindow});
		ObjectIO.saveToFile(Tracer.resultFileLocation, traceObjectResult);
	}

}
