package org.softevo.apibirthmark.tracing.tracehandler.window;

import org.softevo.apibirthmark.constants.Constants;
import org.softevo.apibirthmark.tracing.Tracer;
import org.softevo.apibirthmark.tracing.Tracer.TraceObject;

/**
 * @author schuler
 *
 */
public abstract class AbstractWindow {

	protected static final int DEFAULT_WINDOW_SIZE = 3;

	protected static final int FILL_ENTRY = 0;

	public boolean full;

	protected static int windowSize;

	/* Set the windowSize */
	static {
		String windowSizeString = System
				.getProperty(Constants.PROPERTY_WINDOW_SIZE);
		if (windowSizeString != null) {
			windowSize = Integer.parseInt(windowSizeString);
		} else {
			windowSize = DEFAULT_WINDOW_SIZE;
		}
		Tracer.println("Window size: " + windowSize);
	}

	/**
	 * Return a result window of this window. An instance of
	 * AbstractResultWindow that contains the current contents of this window
	 *
	 * @return
	 */
	public abstract AbstractResultWindow getResultWindow();

	/**
	 * Add a call to the window.
	 *
	 * @param o
	 */
	public abstract void addCall(TraceObject o);

	/**
	 * Return if Window is full, which means that at least n calls were added to
	 * the window, where n is the window size.
	 *
	 * @return
	 */
	public boolean isFull() {
		return full;
	}

	/**
	 * Fill the window with default entries
	 *
	 * @return
	 */
	public abstract boolean fill();
}
