package org.softevo.apibirthmark.tracing.tracehandler.window;

import org.softevo.apibirthmark.constants.Constants;
import org.softevo.apibirthmark.tracing.Tracer.TraceObject;

public class TraceObjectWindow extends AbstractWindow {

	private TraceObject[] traceWindow;

	private int arrayPointer = 0;

	public TraceObjectWindow() {
		traceWindow = new TraceObject[windowSize];
	}

	/* (non-Javadoc)
	 * @see tracing.tracehandler.window.AbstractWindow#addCall(tracing.Tracer.TraceObject)
	 */
	@Override
	public void addCall(TraceObject traceObject) {
		traceWindow[arrayPointer] = traceObject;
		if (!full && arrayPointer == windowSize - 1) {
			full = true;
		}
		arrayPointer = (arrayPointer + 1) % windowSize;
	}

	/* (non-Javadoc)
	 * @see tracing.tracehandler.window.AbstractWindow#getResultWindow()
	 */
	@Override
	public AbstractResultWindow getResultWindow() {
		TraceObject[] copy = new TraceObject[traceWindow.length];
		System.arraycopy(traceWindow, 0, copy, 0, traceWindow.length);
		return new TraceObjectResultWindow(copy);
	}

	/* (non-Javadoc)
	 * @see tracing.tracehandler.window.AbstractWindow#fill()
	 */
	@Override
	public boolean fill() {
		TraceObject fillTraceObject = new TraceObject(Constants.FIll_CLASS_ID, Constants.FILL_METHOD_ID, Constants.FILL_OBJECT_ID, Constants.FIll_CLASS_ID, Constants.FILL_METHOD_ID, Constants.FILL_OBJECT_ID);
		while (!full) {
			addCall(fillTraceObject);
		}
		return false;
	}

}
