package org.softevo.apibirthmark.tracing.tracehandler.window.container;

import org.softevo.apibirthmark.tracing.result.AbstractTraceResult;
import org.softevo.apibirthmark.tracing.tracehandler.window.AbstractWindow;

/**
 * Used to build the call seqeunce set at runtime. new sequences can be added
 * and the result can be reported.
 *
 * @author schuler
 *
 */
public interface AbstractWindowContainer {

	/**
	 * Adds a seqeunce that is to this set
	 *
	 * @param sequence
	 *            Call Sequence that is contained in a window
	 */
	public abstract void add(AbstractWindow sequence);

	/**
	 * Return the call sequence set.
	 *
	 * @return AbstractTraceResult that contains all sequences that were traced
	 */
	public abstract AbstractTraceResult getTraceResult();
}
