package org.softevo.apibirthmark.transformation.bytecodeTransformer;

import org.objectweb.asm.ClassVisitor;
import org.objectweb.asm.ClassWriter;
import org.objectweb.asm.util.CheckClassAdapter;

import org.softevo.apibirthmark.asmadapters.proxies.classHierarchy.ClassHierarchy;
import org.softevo.apibirthmark.asmadapters.proxies.classHierarchy.HierarchyClassAdapter;

/**
 * Provides the corresponding ASM chain to process classes and determines their
 * class hierarchy.
 * 
 * @author schuler
 * 
 */
public class HierarchyTransformer extends BytecodeTransformer {
	private ClassHierarchy classHierarchy;

	public HierarchyTransformer(ClassHierarchy classHierarchy) {
		this.classHierarchy = classHierarchy;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see transformation.bytecodeTransformer.BytecodeTransformer#getTransformer()
	 */
	protected ClassVisitor getTransformer() {
		cw = new ClassWriter(true);
		ClassVisitor cc = new CheckClassAdapter(cw);
		return new HierarchyClassAdapter(cc, classHierarchy);
	}

}
