package org.softevo.apibirthmark.transformation.bytecodeTransformer;

import org.objectweb.asm.ClassVisitor;
import org.objectweb.asm.ClassWriter;
import org.objectweb.asm.util.CheckClassAdapter;

import org.softevo.apibirthmark.tracing.mapping.NameToIDMap;

import org.softevo.apibirthmark.asmadapters.calls.InsertProxyCallsClassAdapter;
import org.softevo.apibirthmark.asmadapters.calls.observed.ObservedCalls;

/**
 * BytecodeTransformer that is used to instrument the classes such that calls to
 * the API are traced (calls are replace with calls to proxy methods)
 *
 * @author schuler
 *
 */
public class InsertCallsTransformer extends BytecodeTransformer {

	private ObservedCalls observedCalls;

	private NameToIDMap idMap;

	public InsertCallsTransformer(NameToIDMap idMap, ObservedCalls observedCalls) {
		this.idMap = idMap;
		this.observedCalls = observedCalls;
	}

	/* (non-Javadoc)
	 * @see transformation.bytecodeTransformer.BytecodeTransformer#getTransformer()
	 */
	protected ClassVisitor getTransformer() {
		cw = new ClassWriter(true);
		ClassVisitor cc = new CheckClassAdapter(cw);
		return new InsertProxyCallsClassAdapter(cc, observedCalls, idMap);
	}

}
