package org.softevo.apibirthmark.util;

import java.io.File;
import java.net.MalformedURLException;
import java.net.URL;

import org.apache.log4j.Logger;

public class PropertyFileLoader {

	private static Logger logger = Logger.getLogger(PropertyFileLoader.class);

	private static final String PROJECT_PROPERTIES = "project.properties";

	private static final String PROPERTIES_FILE_KEY = "properties.file";

	public static URL getPropertyFileLocation() {
		URL url = null;
		ClassLoader classLoader = PropertyFileLoader.class.getClassLoader();
		if(classLoader == null){
			classLoader = ClassLoader.getSystemClassLoader();
		}
		if (classLoader != null) {
			url = classLoader.getResource(PROJECT_PROPERTIES);
		}else{
			System.out.println("No classloader found ");
		}
		if (url == null) {
			String prop = System.getProperty(PROPERTIES_FILE_KEY);
			if (prop != null) {
				try {
					url = new File(prop).toURL();
				} catch (MalformedURLException e) {
					e.printStackTrace();
				}
			}
		}
		if (url == null) {
			throw new RuntimeException(
					String
							.format(
									"Could not find properties file (%s). Either put it  on the classpath or specify the System property  %s",
									PROJECT_PROPERTIES, PROPERTIES_FILE_KEY));
		}
		logger.info(String.format("Location of properties file(%s) : %s",
				PROJECT_PROPERTIES, url.toString()));
		System.out.println(String.format(
				"Location of properties file(%s) : %s", PROJECT_PROPERTIES, url
						.toString()));
		return url;
	}
}
